"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var config_1 = require("../../common/config");
var logging_1 = require("../../common/logging");
var open_1 = __importDefault(require("open"));
var plaidIntegration_1 = require("./plaidIntegration");
var integrations_1 = require("../../types/integrations");
exports["default"] = (function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, new Promise(function (resolve, reject) { return __awaiter(void 0, void 0, void 0, function () {
                var config, plaidConfig, plaid, e_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            console.log('\nThis script will help you add accounts to Plaid.\n');
                            console.log('\n\t1. A page will open in your browser allowing you to link accounts with Plaid.');
                            console.log('\t2. Sign in with your banking provider for each account you wish to link.');
                            console.log("\t3. Click 'Done Linking Accounts' in your browser when you are finished.\n");
                            config = config_1.getConfig();
                            plaidConfig = config.integrations[integrations_1.IntegrationId.Plaid];
                            plaid = new plaidIntegration_1.PlaidIntegration(config);
                            logging_1.logInfo('Account setup in progress.');
                            open_1["default"]("http://localhost:8000?environment=" + plaidConfig.environment);
                            return [4 /*yield*/, plaid.accountSetup()];
                        case 1:
                            _a.sent();
                            logging_1.logInfo('Successfully set up Plaid Account(s).');
                            return [2 /*return*/, resolve()];
                        case 2:
                            e_1 = _a.sent();
                            logging_1.logError('Unable to set up Plaid Account(s).', e_1);
                            return [2 /*return*/, reject()];
                        case 3: return [2 /*return*/];
                    }
                });
            }); })];
    });
}); });
